<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['net.ihe.gazelle.evs.ManageApplicationPreferences']}"/>
    <ui:param name="pageNameUrl" value="administration/applicationConfiguration.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.evs.ManageApplicationPreferences']}"/>
    <ui:define name="body">
        <s:div id="globalDiv">

            <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                <ui:param name="panel_id" value="AllPreferencesPanel"/>


                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.evs.ApplicationPreferences']}"/>
                </ui:define>

                <h:form id="globalForm">

                    <rich:dataTable id="tableId" value="#{applicationConfiguration.applicationPreferences}" var="pref"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="ds"
                                    styleClass="table table-striped  table-responsive">
                        <g:column sortBy="#{'id'}" >
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.Id']}</ui:define>
                            <h:outputText value="#{pref.id}"/>
                        </g:column>
                        <g:column sortBy="#{'preferenceName'}" filterBy="#{'preferenceName'}" sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.PreferenceKey']}</ui:define>
                            <h:outputText value="#{pref.preferenceName}"/>
                        </g:column>
                        <g:column sortBy="#{'className'}" filterBy="#{'className'}" >
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.Class']}</ui:define>
                            <h:outputText value="#{pref.className}"/>
                        </g:column>
                        <g:column filterBy="#{'preferenceValue'}"   sortBy="#{'preferenceValue'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.evs.PreferenceValue']}</ui:define>
                            <h:outputText value="#{pref.preferenceValue}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.Description']}</ui:define>
                            <h:outputText value="#{pref.description}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                            <div class="gzl-never-wrap">

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.evs.EditApplicationPreference']}"
                                        action="#{applicationConfiguration.displayApplicationPreference(pref)}" execute="@this">
                                    <s:span styleClass="gzl-icon-pencil"/>
                                </a4j:commandLink>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.evs.Delete']}" oncomplete="jq162('#delete_pref').modal('show');"
                                        action="#{applicationConfiguration.setSelectedPreference(pref)}" render="delete_pref_form"  execute="@this">
                                    <s:span styleClass="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </div>

                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="tableId"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </h:form>

                <ui:define name="panel_footer">
                    <h:form id="buttonForm">
                        <a4j:region>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.CreateNewApplicationPreference']}"
                                               action="#{applicationConfiguration.createNewApplicationPreference()}"
                                               styleClass="gzl-btn-green" execute="@this"/>
                            <!--  Cache Section -->
                            <a4j:commandButton action="#{applicationConfiguration.resetCache()}"
                                               styleClass="gzl-btn-blue"
                                               value="#{messages['net.ihe.gazelle.evs.ResetResteasyCache']}" render="globalForm"
                                               execute="@this"/>
                            <!--  http headers Section -->
                            <a4j:commandButton action="#{applicationConfiguration.resetHttpHeaders()}"
                                               styleClass="gzl-btn-blue"
                                               value="#{messages['net.ihe.gazelle.evs.SetDefaultHttpHeadersValues']}"
                                               render="globalForm" execute="@this"/>
                            <!--  create missing preferences key -->
                            <a4j:commandButton action="#{applicationConfiguration.createMissingKeys()}"
                                               styleClass="gzl-btn-blue"
                                               value="#{messages['net.ihe.gazelle.evs.CreateMissingPreferences']}"
                                               render="globalForm" execute="@this"/>
                        </a4j:region>
                    </h:form>
                </ui:define>

            </ui:decorate>
        </s:div>

        <h:form id="delete_pref_form">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="delete_pref"/>
                <ui:define name="popup_title">
                    <h:outputText value="#{messages['gazelle.evs.client.DeleteApplicationPreference']}"/>
                </ui:define>
                <h:outputText value="#{messages['gazelle.evs.client.AreYouSureYouWantToDeleteThisPreference']} "/>
                <h:outputText value="#{applicationConfiguration.selectedPreference.preferenceName}"/>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.uploader.cancelCaption']}"
                                       oncomplete="jq162('#delete_pref').modal('hide');"
                                       execute="@this"/>
                    <a4j:commandButton value="#{messages['gazelle.evs.client.Confirm']}"
                                       actionListener="#{applicationConfiguration.deleteSelectedPreference()}"
                                       oncomplete="jq162('#delete_pref').modal('hide');"
                                       styleClass="gzl-btn-red"
                                       render="globalDiv,richmss" execute="@this"/>

                </ui:define>
            </ui:decorate>
        </h:form>

    </ui:define>
</ui:composition>
